#ifndef FRT_ARRAY_H
#define FRT_ARRAY_H

typedef struct Array {
  void **elems;
  int size;
  int allocated;
  void (*free_elem)(void *p);
} Array;

Array *ary_create(int size, void (*free_elem)(void *p));
void ary_destroy(Array *ary);
void ary_set(Array *ary, int index, void *value);
void ary_append(Array *ary, void *value);
void *ary_get(Array *ary, int index);
void ary_delete(Array *ary, int index);
void *ary_remove(Array *ary, int index);

#endif
