#ifndef FRT_BIT_VECTOR_H
#define FRT_BIT_VECTOR_H

#include <global.h>
#include <store.h>

#define BV_INIT_CAPA 256 
typedef struct BitVector {
  uchar *bits;
  int size;
  int capa;
  int count;
  int curr_bit;
} BitVector;

BitVector *bv_create();;
BitVector *bv_create_size(int size);
void bv_destroy(BitVector *bv);
void bv_set(BitVector *bv, int bit);
int bv_get(BitVector *bv, int bit);
void bv_clear(BitVector *bv);
void bv_unset(BitVector *bv, int bit);
void bv_write(BitVector *bv, Store *store, char *name);
BitVector *bv_read(Store *store, char *name);
void bv_scan_reset(BitVector *bv);
int bv_scan_next(BitVector *bv);
int bv_scan_next_from(BitVector *bv, register const int from);

#endif
