#ifndef FRT_GLOBAL_H
#define FRT_GLOBAL_H

#include <stdlib.h>
#include <stdio.h>
#include <assert.h>
/*
#define DEBUG 
#define VALGRIND
*/
#define false 0
#define true 1

typedef unsigned int bool;
typedef unsigned char uchar;
typedef unsigned int uint;

typedef void (*free_ft)(void *key);

#include "lang.h"
#include "except.h"

#define ref(obj) obj->ref_cnt++
#define deref(obj) obj->ref_cnt--

#define MAX_WORD_SIZE 255
#define MAX_FILE_PATH 1024
#define MAX_BUFFER_SIZE 1024
#define ARRAY_INIT_SIZE 4

#define NELEMS(array) sizeof(array)/sizeof(array[0])

#define ZEROSET(ptr, type, n) memset(ptr, 0, sizeof(type)*(n))
#define ALLOC_AND_ZERO(type) (type*)memset(emalloc(sizeof(type)), 0, sizeof(type))
#define ALLOC_AND_ZERO_N(type,n) (type*)ZEROSET(emalloc(sizeof(type)*(n)), type, n)

#define MIN(a, b) ((a) < (b) ? (a) : (b))
#define MAX(a, b) ((a) > (b) ? (a) : (b))

#define MIN3(a, b, c) ((a) < (b) ? ((a) < (c) ? (a) : (c)) : ((b) < (c) ? (b) : (c)))
#define MAX3(a, b, c) ((a) > (b) ? ((a) > (c) ? (a) : (c)) : ((b) > (c) ? (b) : (c)))

#define RECAPA(self, len, capa, ptr, type) \
  do {\
    if (self->len >= self->capa) {\
      if (self->capa) {\
        self->capa *= 2;\
      } else {\
        self->capa = 4;\
      }\
      REALLOC_N(self->ptr, type, self->capa);\
    }\
  } while (0)

#define Jx fprintf(stderr,"%s, %d: %s\n", __FILE__, __LINE__, __func__);
#define Xj fprintf(stdout,"%s, %d: %s\n", __FILE__, __LINE__, __func__);

extern void *emalloc(size_t n);
extern void *erealloc(void *ptr, size_t n);
extern char *estrdup(const char *s);
extern char *epstrdup(const char *fmt, int len, ...);
extern char *estrcat(char *str, char *str_cat);

extern const char *EMPTY_STRING;

extern int scmp(const void *p1, const void *p2);
extern int icmp(const void *p1, const void *p2);
extern int icmp_risky(const void *p1, const void *p2);

extern int min2(int a, int b);
extern int min3(int a, int b, int c);
extern int max2(int a, int b);
extern int max3(int a, int b, int c);

extern char *dbl_to_s(char *buf, double num);
extern void lower_str(char *str);
extern char *strfmt(const char *fmt, ...);
#endif
