#ifndef FRT_HASHSET_H
#define FRT_HASHSET_H

#include "hash.h"
#include "array.h"
#include "global.h"

typedef struct HashSet {
  int capa;
  int size;
  void **elems;
  HshTable *ht;
  void (*free_elem)(void *p);
} HashSet;

HashSet *hs_create(unsigned int (*hash)(const void *p),
                   int (*eq)(const void *p1, const void *p2),
                   void (*free_elem)(void *p));
HashSet *hs_str_create(void (*free_elem)(void *p));
void hs_destroy(HashSet *hs);
void hs_destroy_all(HashSet *hs);
int hs_add(HashSet *hs, void *elem);
int hs_del(HashSet *hs, void *elem);
void *hs_rem(HashSet *hs, void *elem);
int hs_exists(HashSet *hs, void *elem);
HashSet *hs_merge(HashSet *hs, HashSet *other);
void *hs_orig(HashSet *hs, void *elem);
void hs_clear(HashSet *self);

/* TODO: finish these functions.
int hs_osf(HashSet *hs, void *elem);
HashSet hs_or(HashSet *hs1, HashSet *h2);
HashSet hs_excl_or(HashSet *hs1, HashSet *h2);
HashSet hs_and(HashSet *hs1, HashSet *h2);
HashSet hs_mask(HashSet *hs1, HashSet *h2);
*/

#endif
