#ifndef FRT_PRIORITYQUEUE_H
#define FRT_PRIORITYQUEUE_H

#include "global.h"

typedef bool (*lt_ft)(void *p1, void *p2);

typedef struct PriorityQueue {
  int count;
  int size;
  void **heap;
  lt_ft lt;
  //bool (*lt)(void *p1, void *p2);
  free_ft free_elem;
} PriorityQueue;

PriorityQueue *pq_create(int max_size, bool (*less_than)(void *p1, void *p2));
void pq_destroy(PriorityQueue *pq);
void pq_push(PriorityQueue *pq, void *elem);
void *pq_top(PriorityQueue *pq);
void *pq_pop(PriorityQueue *pq);
void pq_down(PriorityQueue *pq);
void pq_clear(PriorityQueue *pq);
int pq_insert(PriorityQueue *pq, void *elem);
#define pq_full(pq) ((pq)->count == (pq)->size)

typedef struct PriorityQueue2 {
  int count;
  int size;
  void **heap;
  void *data;
  bool (*lt)(struct PriorityQueue2 *pq, void *p1, void *p2);
  void (*free_elem)(void *p);
  free_ft destroy;
} PriorityQueue2;

PriorityQueue2 *pq2_create(int max_size,
    bool (*less_than)(PriorityQueue2 *pq, void *p1, void *p2),
    free_ft destroy);
void pq2_destroy(PriorityQueue2 *pq);
void pq2_push(PriorityQueue2 *pq, void *elem);
void *pq2_top(PriorityQueue2 *pq);
void *pq2_pop(PriorityQueue2 *pq);
void pq2_down(PriorityQueue2 *pq);
void pq2_clear(PriorityQueue2 *pq);
int pq2_insert(PriorityQueue2 *pq, void *elem);
#endif
